#include "tonemapping.h"
#include "utilities.h"
#include <stdio.h>
#include <stdlib.h>

void tonemapping(Mat* img) 
{
  MyTimer timer;
  timer.Start();
  int width = img->cols;
  int height = img->rows; 
    
  float * outData = new float[width*height*3];
  for (int h = 0; h<height; h++)
  {
    for (int w = 0; w < width; w++)
    {
      int pixIdx = w+(h*width);
      outData[pixIdx*3 + 0] = img->at<Vec3f>(h,w)[0];  
      outData[pixIdx*3 + 1] = img->at<Vec3f>(h,w)[1];  
      outData[pixIdx*3 + 2] = img->at<Vec3f>(h,w)[2];  
    }
  }

  //write outData as an exr an save it and then read it back in as a float* 
  WriteExrRGB("Result/BeforeDurandTonemapping.exr", outData, width, height);
  int i = system("./../TMlib/FredoToneMap/tone_mapping Result/BeforeDurandTonemapping.exr Result/AfterDurandTonemapping.ppm 50.0");  
  printf("system call returned %d\n", i);
  
  timer.Stop();
  //need to call durands' tonemapping.
  timer.Print("tonemapping");
}
